// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vault-secrets/preview/2023-11-28/models"
)

// NewCreateGcpSmSyncIntegrationParams creates a new CreateGcpSmSyncIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateGcpSmSyncIntegrationParams() *CreateGcpSmSyncIntegrationParams {
	return &CreateGcpSmSyncIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateGcpSmSyncIntegrationParamsWithTimeout creates a new CreateGcpSmSyncIntegrationParams object
// with the ability to set a timeout on a request.
func NewCreateGcpSmSyncIntegrationParamsWithTimeout(timeout time.Duration) *CreateGcpSmSyncIntegrationParams {
	return &CreateGcpSmSyncIntegrationParams{
		timeout: timeout,
	}
}

// NewCreateGcpSmSyncIntegrationParamsWithContext creates a new CreateGcpSmSyncIntegrationParams object
// with the ability to set a context for a request.
func NewCreateGcpSmSyncIntegrationParamsWithContext(ctx context.Context) *CreateGcpSmSyncIntegrationParams {
	return &CreateGcpSmSyncIntegrationParams{
		Context: ctx,
	}
}

// NewCreateGcpSmSyncIntegrationParamsWithHTTPClient creates a new CreateGcpSmSyncIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateGcpSmSyncIntegrationParamsWithHTTPClient(client *http.Client) *CreateGcpSmSyncIntegrationParams {
	return &CreateGcpSmSyncIntegrationParams{
		HTTPClient: client,
	}
}

/*
CreateGcpSmSyncIntegrationParams contains all the parameters to send to the API endpoint

	for the create gcp sm sync integration operation.

	Typically these are written to a http.Request.
*/
type CreateGcpSmSyncIntegrationParams struct {

	// Body.
	Body *models.SecretServiceCreateGcpSmSyncIntegrationBody

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create gcp sm sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGcpSmSyncIntegrationParams) WithDefaults() *CreateGcpSmSyncIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create gcp sm sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGcpSmSyncIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithTimeout(timeout time.Duration) *CreateGcpSmSyncIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithContext(ctx context.Context) *CreateGcpSmSyncIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithHTTPClient(client *http.Client) *CreateGcpSmSyncIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithBody(body *models.SecretServiceCreateGcpSmSyncIntegrationBody) *CreateGcpSmSyncIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetBody(body *models.SecretServiceCreateGcpSmSyncIntegrationBody) {
	o.Body = body
}

// WithOrganizationID adds the organizationID to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithOrganizationID(organizationID string) *CreateGcpSmSyncIntegrationParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) WithProjectID(projectID string) *CreateGcpSmSyncIntegrationParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the create gcp sm sync integration params
func (o *CreateGcpSmSyncIntegrationParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateGcpSmSyncIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
