// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vault-secrets/preview/2023-11-28/models"
)

// NewCreateGhRepoSyncIntegrationParams creates a new CreateGhRepoSyncIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateGhRepoSyncIntegrationParams() *CreateGhRepoSyncIntegrationParams {
	return &CreateGhRepoSyncIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateGhRepoSyncIntegrationParamsWithTimeout creates a new CreateGhRepoSyncIntegrationParams object
// with the ability to set a timeout on a request.
func NewCreateGhRepoSyncIntegrationParamsWithTimeout(timeout time.Duration) *CreateGhRepoSyncIntegrationParams {
	return &CreateGhRepoSyncIntegrationParams{
		timeout: timeout,
	}
}

// NewCreateGhRepoSyncIntegrationParamsWithContext creates a new CreateGhRepoSyncIntegrationParams object
// with the ability to set a context for a request.
func NewCreateGhRepoSyncIntegrationParamsWithContext(ctx context.Context) *CreateGhRepoSyncIntegrationParams {
	return &CreateGhRepoSyncIntegrationParams{
		Context: ctx,
	}
}

// NewCreateGhRepoSyncIntegrationParamsWithHTTPClient creates a new CreateGhRepoSyncIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateGhRepoSyncIntegrationParamsWithHTTPClient(client *http.Client) *CreateGhRepoSyncIntegrationParams {
	return &CreateGhRepoSyncIntegrationParams{
		HTTPClient: client,
	}
}

/*
CreateGhRepoSyncIntegrationParams contains all the parameters to send to the API endpoint

	for the create gh repo sync integration operation.

	Typically these are written to a http.Request.
*/
type CreateGhRepoSyncIntegrationParams struct {

	// Body.
	Body *models.SecretServiceCreateGhRepoSyncIntegrationBody

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create gh repo sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGhRepoSyncIntegrationParams) WithDefaults() *CreateGhRepoSyncIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create gh repo sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGhRepoSyncIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) WithTimeout(timeout time.Duration) *CreateGhRepoSyncIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) WithContext(ctx context.Context) *CreateGhRepoSyncIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) WithHTTPClient(client *http.Client) *CreateGhRepoSyncIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) WithBody(body *models.SecretServiceCreateGhRepoSyncIntegrationBody) *CreateGhRepoSyncIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) SetBody(body *models.SecretServiceCreateGhRepoSyncIntegrationBody) {
	o.Body = body
}

// WithOrganizationID adds the organizationID to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) WithOrganizationID(organizationID string) *CreateGhRepoSyncIntegrationParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) WithProjectID(projectID string) *CreateGhRepoSyncIntegrationParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the create gh repo sync integration params
func (o *CreateGhRepoSyncIntegrationParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateGhRepoSyncIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
