// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vault-secrets/preview/2023-11-28/models"
)

// NewCreateVercelProjectSyncIntegrationParams creates a new CreateVercelProjectSyncIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateVercelProjectSyncIntegrationParams() *CreateVercelProjectSyncIntegrationParams {
	return &CreateVercelProjectSyncIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateVercelProjectSyncIntegrationParamsWithTimeout creates a new CreateVercelProjectSyncIntegrationParams object
// with the ability to set a timeout on a request.
func NewCreateVercelProjectSyncIntegrationParamsWithTimeout(timeout time.Duration) *CreateVercelProjectSyncIntegrationParams {
	return &CreateVercelProjectSyncIntegrationParams{
		timeout: timeout,
	}
}

// NewCreateVercelProjectSyncIntegrationParamsWithContext creates a new CreateVercelProjectSyncIntegrationParams object
// with the ability to set a context for a request.
func NewCreateVercelProjectSyncIntegrationParamsWithContext(ctx context.Context) *CreateVercelProjectSyncIntegrationParams {
	return &CreateVercelProjectSyncIntegrationParams{
		Context: ctx,
	}
}

// NewCreateVercelProjectSyncIntegrationParamsWithHTTPClient creates a new CreateVercelProjectSyncIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateVercelProjectSyncIntegrationParamsWithHTTPClient(client *http.Client) *CreateVercelProjectSyncIntegrationParams {
	return &CreateVercelProjectSyncIntegrationParams{
		HTTPClient: client,
	}
}

/*
CreateVercelProjectSyncIntegrationParams contains all the parameters to send to the API endpoint

	for the create vercel project sync integration operation.

	Typically these are written to a http.Request.
*/
type CreateVercelProjectSyncIntegrationParams struct {

	// Body.
	Body *models.SecretServiceCreateVercelProjectSyncIntegrationBody

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create vercel project sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateVercelProjectSyncIntegrationParams) WithDefaults() *CreateVercelProjectSyncIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create vercel project sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateVercelProjectSyncIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithTimeout(timeout time.Duration) *CreateVercelProjectSyncIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithContext(ctx context.Context) *CreateVercelProjectSyncIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithHTTPClient(client *http.Client) *CreateVercelProjectSyncIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithBody(body *models.SecretServiceCreateVercelProjectSyncIntegrationBody) *CreateVercelProjectSyncIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetBody(body *models.SecretServiceCreateVercelProjectSyncIntegrationBody) {
	o.Body = body
}

// WithOrganizationID adds the organizationID to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithOrganizationID(organizationID string) *CreateVercelProjectSyncIntegrationParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) WithProjectID(projectID string) *CreateVercelProjectSyncIntegrationParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the create vercel project sync integration params
func (o *CreateVercelProjectSyncIntegrationParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateVercelProjectSyncIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
