// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-vault-secrets/preview/2023-11-28/models"
)

// ForceSyncReader is a Reader for the ForceSync structure.
type ForceSyncReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ForceSyncReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewForceSyncOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewForceSyncDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewForceSyncOK creates a ForceSyncOK with default headers values
func NewForceSyncOK() *ForceSyncOK {
	return &ForceSyncOK{}
}

/*
ForceSyncOK describes a response with status code 200, with default header values.

A successful response.
*/
type ForceSyncOK struct {
	Payload models.Secrets20231128ForceSyncResponse
}

// IsSuccess returns true when this force sync o k response has a 2xx status code
func (o *ForceSyncOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this force sync o k response has a 3xx status code
func (o *ForceSyncOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this force sync o k response has a 4xx status code
func (o *ForceSyncOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this force sync o k response has a 5xx status code
func (o *ForceSyncOK) IsServerError() bool {
	return false
}

// IsCode returns true when this force sync o k response a status code equal to that given
func (o *ForceSyncOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the force sync o k response
func (o *ForceSyncOK) Code() int {
	return 200
}

func (o *ForceSyncOK) Error() string {
	return fmt.Sprintf("[POST /secrets/2023-11-28/organizations/{organization_id}/projects/{project_id}/sync/force][%d] forceSyncOK  %+v", 200, o.Payload)
}

func (o *ForceSyncOK) String() string {
	return fmt.Sprintf("[POST /secrets/2023-11-28/organizations/{organization_id}/projects/{project_id}/sync/force][%d] forceSyncOK  %+v", 200, o.Payload)
}

func (o *ForceSyncOK) GetPayload() models.Secrets20231128ForceSyncResponse {
	return o.Payload
}

func (o *ForceSyncOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewForceSyncDefault creates a ForceSyncDefault with default headers values
func NewForceSyncDefault(code int) *ForceSyncDefault {
	return &ForceSyncDefault{
		_statusCode: code,
	}
}

/*
ForceSyncDefault describes a response with status code -1, with default header values.

An unexpected error response.
*/
type ForceSyncDefault struct {
	_statusCode int

	Payload *models.GooglerpcStatus
}

// IsSuccess returns true when this force sync default response has a 2xx status code
func (o *ForceSyncDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this force sync default response has a 3xx status code
func (o *ForceSyncDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this force sync default response has a 4xx status code
func (o *ForceSyncDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this force sync default response has a 5xx status code
func (o *ForceSyncDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this force sync default response a status code equal to that given
func (o *ForceSyncDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the force sync default response
func (o *ForceSyncDefault) Code() int {
	return o._statusCode
}

func (o *ForceSyncDefault) Error() string {
	return fmt.Sprintf("[POST /secrets/2023-11-28/organizations/{organization_id}/projects/{project_id}/sync/force][%d] ForceSync default  %+v", o._statusCode, o.Payload)
}

func (o *ForceSyncDefault) String() string {
	return fmt.Sprintf("[POST /secrets/2023-11-28/organizations/{organization_id}/projects/{project_id}/sync/force][%d] ForceSync default  %+v", o._statusCode, o.Payload)
}

func (o *ForceSyncDefault) GetPayload() *models.GooglerpcStatus {
	return o.Payload
}

func (o *ForceSyncDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.GooglerpcStatus)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
