// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewListGitHubInstallationsParams creates a new ListGitHubInstallationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListGitHubInstallationsParams() *ListGitHubInstallationsParams {
	return &ListGitHubInstallationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListGitHubInstallationsParamsWithTimeout creates a new ListGitHubInstallationsParams object
// with the ability to set a timeout on a request.
func NewListGitHubInstallationsParamsWithTimeout(timeout time.Duration) *ListGitHubInstallationsParams {
	return &ListGitHubInstallationsParams{
		timeout: timeout,
	}
}

// NewListGitHubInstallationsParamsWithContext creates a new ListGitHubInstallationsParams object
// with the ability to set a context for a request.
func NewListGitHubInstallationsParamsWithContext(ctx context.Context) *ListGitHubInstallationsParams {
	return &ListGitHubInstallationsParams{
		Context: ctx,
	}
}

// NewListGitHubInstallationsParamsWithHTTPClient creates a new ListGitHubInstallationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListGitHubInstallationsParamsWithHTTPClient(client *http.Client) *ListGitHubInstallationsParams {
	return &ListGitHubInstallationsParams{
		HTTPClient: client,
	}
}

/*
ListGitHubInstallationsParams contains all the parameters to send to the API endpoint

	for the list git hub installations operation.

	Typically these are written to a http.Request.
*/
type ListGitHubInstallationsParams struct {

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	// State.
	State *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list git hub installations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListGitHubInstallationsParams) WithDefaults() *ListGitHubInstallationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list git hub installations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListGitHubInstallationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list git hub installations params
func (o *ListGitHubInstallationsParams) WithTimeout(timeout time.Duration) *ListGitHubInstallationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list git hub installations params
func (o *ListGitHubInstallationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list git hub installations params
func (o *ListGitHubInstallationsParams) WithContext(ctx context.Context) *ListGitHubInstallationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list git hub installations params
func (o *ListGitHubInstallationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list git hub installations params
func (o *ListGitHubInstallationsParams) WithHTTPClient(client *http.Client) *ListGitHubInstallationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list git hub installations params
func (o *ListGitHubInstallationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrganizationID adds the organizationID to the list git hub installations params
func (o *ListGitHubInstallationsParams) WithOrganizationID(organizationID string) *ListGitHubInstallationsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the list git hub installations params
func (o *ListGitHubInstallationsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the list git hub installations params
func (o *ListGitHubInstallationsParams) WithProjectID(projectID string) *ListGitHubInstallationsParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the list git hub installations params
func (o *ListGitHubInstallationsParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WithState adds the state to the list git hub installations params
func (o *ListGitHubInstallationsParams) WithState(state *string) *ListGitHubInstallationsParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the list git hub installations params
func (o *ListGitHubInstallationsParams) SetState(state *string) {
	o.State = state
}

// WriteToRequest writes these params to a swagger request
func (o *ListGitHubInstallationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if o.State != nil {

		// query param state
		var qrState string

		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {

			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
