// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewListSyncInstallationsParams creates a new ListSyncInstallationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListSyncInstallationsParams() *ListSyncInstallationsParams {
	return &ListSyncInstallationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListSyncInstallationsParamsWithTimeout creates a new ListSyncInstallationsParams object
// with the ability to set a timeout on a request.
func NewListSyncInstallationsParamsWithTimeout(timeout time.Duration) *ListSyncInstallationsParams {
	return &ListSyncInstallationsParams{
		timeout: timeout,
	}
}

// NewListSyncInstallationsParamsWithContext creates a new ListSyncInstallationsParams object
// with the ability to set a context for a request.
func NewListSyncInstallationsParamsWithContext(ctx context.Context) *ListSyncInstallationsParams {
	return &ListSyncInstallationsParams{
		Context: ctx,
	}
}

// NewListSyncInstallationsParamsWithHTTPClient creates a new ListSyncInstallationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListSyncInstallationsParamsWithHTTPClient(client *http.Client) *ListSyncInstallationsParams {
	return &ListSyncInstallationsParams{
		HTTPClient: client,
	}
}

/*
ListSyncInstallationsParams contains all the parameters to send to the API endpoint

	for the list sync installations operation.

	Typically these are written to a http.Request.
*/
type ListSyncInstallationsParams struct {

	// OrganizationID.
	OrganizationID string

	// ProjectID.
	ProjectID string

	// Type.
	Type *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list sync installations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListSyncInstallationsParams) WithDefaults() *ListSyncInstallationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list sync installations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListSyncInstallationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list sync installations params
func (o *ListSyncInstallationsParams) WithTimeout(timeout time.Duration) *ListSyncInstallationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list sync installations params
func (o *ListSyncInstallationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list sync installations params
func (o *ListSyncInstallationsParams) WithContext(ctx context.Context) *ListSyncInstallationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list sync installations params
func (o *ListSyncInstallationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list sync installations params
func (o *ListSyncInstallationsParams) WithHTTPClient(client *http.Client) *ListSyncInstallationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list sync installations params
func (o *ListSyncInstallationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrganizationID adds the organizationID to the list sync installations params
func (o *ListSyncInstallationsParams) WithOrganizationID(organizationID string) *ListSyncInstallationsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the list sync installations params
func (o *ListSyncInstallationsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithProjectID adds the projectID to the list sync installations params
func (o *ListSyncInstallationsParams) WithProjectID(projectID string) *ListSyncInstallationsParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the list sync installations params
func (o *ListSyncInstallationsParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WithType adds the typeVar to the list sync installations params
func (o *ListSyncInstallationsParams) WithType(typeVar *string) *ListSyncInstallationsParams {
	o.SetType(typeVar)
	return o
}

// SetType adds the type to the list sync installations params
func (o *ListSyncInstallationsParams) SetType(typeVar *string) {
	o.Type = typeVar
}

// WriteToRequest writes these params to a swagger request
func (o *ListSyncInstallationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if o.Type != nil {

		// query param type
		var qrType string

		if o.Type != nil {
			qrType = *o.Type
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
