// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewListSyncIntegrationsParams creates a new ListSyncIntegrationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewListSyncIntegrationsParams() *ListSyncIntegrationsParams {
	return &ListSyncIntegrationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewListSyncIntegrationsParamsWithTimeout creates a new ListSyncIntegrationsParams object
// with the ability to set a timeout on a request.
func NewListSyncIntegrationsParamsWithTimeout(timeout time.Duration) *ListSyncIntegrationsParams {
	return &ListSyncIntegrationsParams{
		timeout: timeout,
	}
}

// NewListSyncIntegrationsParamsWithContext creates a new ListSyncIntegrationsParams object
// with the ability to set a context for a request.
func NewListSyncIntegrationsParamsWithContext(ctx context.Context) *ListSyncIntegrationsParams {
	return &ListSyncIntegrationsParams{
		Context: ctx,
	}
}

// NewListSyncIntegrationsParamsWithHTTPClient creates a new ListSyncIntegrationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewListSyncIntegrationsParamsWithHTTPClient(client *http.Client) *ListSyncIntegrationsParams {
	return &ListSyncIntegrationsParams{
		HTTPClient: client,
	}
}

/*
ListSyncIntegrationsParams contains all the parameters to send to the API endpoint

	for the list sync integrations operation.

	Typically these are written to a http.Request.
*/
type ListSyncIntegrationsParams struct {

	// AppName.
	AppName *string

	// Name.
	Name *string

	// OrganizationID.
	OrganizationID string

	/* PaginationNextPageToken.

	     Specifies a page token to use to retrieve the next page. Set this to the
	`next_page_token` returned by previous list requests to get the next page of
	results. If set, `previous_page_token` must not be set.
	*/
	PaginationNextPageToken *string

	/* PaginationPageSize.

	     The max number of results per page that should be returned. If the number
	of available results is larger than `page_size`, a `next_page_token` is
	returned which can be used to get the next page of results in subsequent
	requests. A value of zero will cause `page_size` to be defaulted.

	     Format: int64
	*/
	PaginationPageSize *int64

	/* PaginationPreviousPageToken.

	     Specifies a page token to use to retrieve the previous page. Set this to
	the `previous_page_token` returned by previous list requests to get the
	previous page of results. If set, `next_page_token` must not be set.
	*/
	PaginationPreviousPageToken *string

	// ProjectID.
	ProjectID string

	// Type.
	Type *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the list sync integrations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListSyncIntegrationsParams) WithDefaults() *ListSyncIntegrationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the list sync integrations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ListSyncIntegrationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithTimeout(timeout time.Duration) *ListSyncIntegrationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithContext(ctx context.Context) *ListSyncIntegrationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithHTTPClient(client *http.Client) *ListSyncIntegrationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppName adds the appName to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithAppName(appName *string) *ListSyncIntegrationsParams {
	o.SetAppName(appName)
	return o
}

// SetAppName adds the appName to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetAppName(appName *string) {
	o.AppName = appName
}

// WithName adds the name to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithName(name *string) *ListSyncIntegrationsParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetName(name *string) {
	o.Name = name
}

// WithOrganizationID adds the organizationID to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithOrganizationID(organizationID string) *ListSyncIntegrationsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WithPaginationNextPageToken adds the paginationNextPageToken to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithPaginationNextPageToken(paginationNextPageToken *string) *ListSyncIntegrationsParams {
	o.SetPaginationNextPageToken(paginationNextPageToken)
	return o
}

// SetPaginationNextPageToken adds the paginationNextPageToken to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetPaginationNextPageToken(paginationNextPageToken *string) {
	o.PaginationNextPageToken = paginationNextPageToken
}

// WithPaginationPageSize adds the paginationPageSize to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithPaginationPageSize(paginationPageSize *int64) *ListSyncIntegrationsParams {
	o.SetPaginationPageSize(paginationPageSize)
	return o
}

// SetPaginationPageSize adds the paginationPageSize to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetPaginationPageSize(paginationPageSize *int64) {
	o.PaginationPageSize = paginationPageSize
}

// WithPaginationPreviousPageToken adds the paginationPreviousPageToken to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithPaginationPreviousPageToken(paginationPreviousPageToken *string) *ListSyncIntegrationsParams {
	o.SetPaginationPreviousPageToken(paginationPreviousPageToken)
	return o
}

// SetPaginationPreviousPageToken adds the paginationPreviousPageToken to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetPaginationPreviousPageToken(paginationPreviousPageToken *string) {
	o.PaginationPreviousPageToken = paginationPreviousPageToken
}

// WithProjectID adds the projectID to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithProjectID(projectID string) *ListSyncIntegrationsParams {
	o.SetProjectID(projectID)
	return o
}

// SetProjectID adds the projectId to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetProjectID(projectID string) {
	o.ProjectID = projectID
}

// WithType adds the typeVar to the list sync integrations params
func (o *ListSyncIntegrationsParams) WithType(typeVar *string) *ListSyncIntegrationsParams {
	o.SetType(typeVar)
	return o
}

// SetType adds the type to the list sync integrations params
func (o *ListSyncIntegrationsParams) SetType(typeVar *string) {
	o.Type = typeVar
}

// WriteToRequest writes these params to a swagger request
func (o *ListSyncIntegrationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AppName != nil {

		// query param app_name
		var qrAppName string

		if o.AppName != nil {
			qrAppName = *o.AppName
		}
		qAppName := qrAppName
		if qAppName != "" {

			if err := r.SetQueryParam("app_name", qAppName); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	if o.PaginationNextPageToken != nil {

		// query param pagination.next_page_token
		var qrPaginationNextPageToken string

		if o.PaginationNextPageToken != nil {
			qrPaginationNextPageToken = *o.PaginationNextPageToken
		}
		qPaginationNextPageToken := qrPaginationNextPageToken
		if qPaginationNextPageToken != "" {

			if err := r.SetQueryParam("pagination.next_page_token", qPaginationNextPageToken); err != nil {
				return err
			}
		}
	}

	if o.PaginationPageSize != nil {

		// query param pagination.page_size
		var qrPaginationPageSize int64

		if o.PaginationPageSize != nil {
			qrPaginationPageSize = *o.PaginationPageSize
		}
		qPaginationPageSize := swag.FormatInt64(qrPaginationPageSize)
		if qPaginationPageSize != "" {

			if err := r.SetQueryParam("pagination.page_size", qPaginationPageSize); err != nil {
				return err
			}
		}
	}

	if o.PaginationPreviousPageToken != nil {

		// query param pagination.previous_page_token
		var qrPaginationPreviousPageToken string

		if o.PaginationPreviousPageToken != nil {
			qrPaginationPreviousPageToken = *o.PaginationPreviousPageToken
		}
		qPaginationPreviousPageToken := qrPaginationPreviousPageToken
		if qPaginationPreviousPageToken != "" {

			if err := r.SetQueryParam("pagination.previous_page_token", qPaginationPreviousPageToken); err != nil {
				return err
			}
		}
	}

	// path param project_id
	if err := r.SetPathParam("project_id", o.ProjectID); err != nil {
		return err
	}

	if o.Type != nil {

		// query param type
		var qrType string

		if o.Type != nil {
			qrType = *o.Type
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
