// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUpdateGhRepoSyncIntegrationParams creates a new UpdateGhRepoSyncIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateGhRepoSyncIntegrationParams() *UpdateGhRepoSyncIntegrationParams {
	return &UpdateGhRepoSyncIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateGhRepoSyncIntegrationParamsWithTimeout creates a new UpdateGhRepoSyncIntegrationParams object
// with the ability to set a timeout on a request.
func NewUpdateGhRepoSyncIntegrationParamsWithTimeout(timeout time.Duration) *UpdateGhRepoSyncIntegrationParams {
	return &UpdateGhRepoSyncIntegrationParams{
		timeout: timeout,
	}
}

// NewUpdateGhRepoSyncIntegrationParamsWithContext creates a new UpdateGhRepoSyncIntegrationParams object
// with the ability to set a context for a request.
func NewUpdateGhRepoSyncIntegrationParamsWithContext(ctx context.Context) *UpdateGhRepoSyncIntegrationParams {
	return &UpdateGhRepoSyncIntegrationParams{
		Context: ctx,
	}
}

// NewUpdateGhRepoSyncIntegrationParamsWithHTTPClient creates a new UpdateGhRepoSyncIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateGhRepoSyncIntegrationParamsWithHTTPClient(client *http.Client) *UpdateGhRepoSyncIntegrationParams {
	return &UpdateGhRepoSyncIntegrationParams{
		HTTPClient: client,
	}
}

/*
UpdateGhRepoSyncIntegrationParams contains all the parameters to send to the API endpoint

	for the update gh repo sync integration operation.

	Typically these are written to a http.Request.
*/
type UpdateGhRepoSyncIntegrationParams struct {

	// Body.
	Body UpdateGhRepoSyncIntegrationBody

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	// Name.
	Name string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update gh repo sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateGhRepoSyncIntegrationParams) WithDefaults() *UpdateGhRepoSyncIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update gh repo sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateGhRepoSyncIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) WithTimeout(timeout time.Duration) *UpdateGhRepoSyncIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) WithContext(ctx context.Context) *UpdateGhRepoSyncIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) WithHTTPClient(client *http.Client) *UpdateGhRepoSyncIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) WithBody(body UpdateGhRepoSyncIntegrationBody) *UpdateGhRepoSyncIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) SetBody(body UpdateGhRepoSyncIntegrationBody) {
	o.Body = body
}

// WithLocationOrganizationID adds the locationOrganizationID to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) WithLocationOrganizationID(locationOrganizationID string) *UpdateGhRepoSyncIntegrationParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) WithLocationProjectID(locationProjectID string) *UpdateGhRepoSyncIntegrationParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WithName adds the name to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) WithName(name string) *UpdateGhRepoSyncIntegrationParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the update gh repo sync integration params
func (o *UpdateGhRepoSyncIntegrationParams) SetName(name string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateGhRepoSyncIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
