// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUpsertAwsSmSyncIntegrationParams creates a new UpsertAwsSmSyncIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpsertAwsSmSyncIntegrationParams() *UpsertAwsSmSyncIntegrationParams {
	return &UpsertAwsSmSyncIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpsertAwsSmSyncIntegrationParamsWithTimeout creates a new UpsertAwsSmSyncIntegrationParams object
// with the ability to set a timeout on a request.
func NewUpsertAwsSmSyncIntegrationParamsWithTimeout(timeout time.Duration) *UpsertAwsSmSyncIntegrationParams {
	return &UpsertAwsSmSyncIntegrationParams{
		timeout: timeout,
	}
}

// NewUpsertAwsSmSyncIntegrationParamsWithContext creates a new UpsertAwsSmSyncIntegrationParams object
// with the ability to set a context for a request.
func NewUpsertAwsSmSyncIntegrationParamsWithContext(ctx context.Context) *UpsertAwsSmSyncIntegrationParams {
	return &UpsertAwsSmSyncIntegrationParams{
		Context: ctx,
	}
}

// NewUpsertAwsSmSyncIntegrationParamsWithHTTPClient creates a new UpsertAwsSmSyncIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpsertAwsSmSyncIntegrationParamsWithHTTPClient(client *http.Client) *UpsertAwsSmSyncIntegrationParams {
	return &UpsertAwsSmSyncIntegrationParams{
		HTTPClient: client,
	}
}

/*
UpsertAwsSmSyncIntegrationParams contains all the parameters to send to the API endpoint

	for the upsert aws sm sync integration operation.

	Typically these are written to a http.Request.
*/
type UpsertAwsSmSyncIntegrationParams struct {

	// Body.
	Body UpsertAwsSmSyncIntegrationBody

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the upsert aws sm sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpsertAwsSmSyncIntegrationParams) WithDefaults() *UpsertAwsSmSyncIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the upsert aws sm sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpsertAwsSmSyncIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) WithTimeout(timeout time.Duration) *UpsertAwsSmSyncIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) WithContext(ctx context.Context) *UpsertAwsSmSyncIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) WithHTTPClient(client *http.Client) *UpsertAwsSmSyncIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) WithBody(body UpsertAwsSmSyncIntegrationBody) *UpsertAwsSmSyncIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) SetBody(body UpsertAwsSmSyncIntegrationBody) {
	o.Body = body
}

// WithLocationOrganizationID adds the locationOrganizationID to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) WithLocationOrganizationID(locationOrganizationID string) *UpsertAwsSmSyncIntegrationParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) WithLocationProjectID(locationProjectID string) *UpsertAwsSmSyncIntegrationParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the upsert aws sm sync integration params
func (o *UpsertAwsSmSyncIntegrationParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *UpsertAwsSmSyncIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
