// Code generated by go-swagger; DO NOT EDIT.

package secret_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUpsertGhRepoSyncIntegrationParams creates a new UpsertGhRepoSyncIntegrationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpsertGhRepoSyncIntegrationParams() *UpsertGhRepoSyncIntegrationParams {
	return &UpsertGhRepoSyncIntegrationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpsertGhRepoSyncIntegrationParamsWithTimeout creates a new UpsertGhRepoSyncIntegrationParams object
// with the ability to set a timeout on a request.
func NewUpsertGhRepoSyncIntegrationParamsWithTimeout(timeout time.Duration) *UpsertGhRepoSyncIntegrationParams {
	return &UpsertGhRepoSyncIntegrationParams{
		timeout: timeout,
	}
}

// NewUpsertGhRepoSyncIntegrationParamsWithContext creates a new UpsertGhRepoSyncIntegrationParams object
// with the ability to set a context for a request.
func NewUpsertGhRepoSyncIntegrationParamsWithContext(ctx context.Context) *UpsertGhRepoSyncIntegrationParams {
	return &UpsertGhRepoSyncIntegrationParams{
		Context: ctx,
	}
}

// NewUpsertGhRepoSyncIntegrationParamsWithHTTPClient creates a new UpsertGhRepoSyncIntegrationParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpsertGhRepoSyncIntegrationParamsWithHTTPClient(client *http.Client) *UpsertGhRepoSyncIntegrationParams {
	return &UpsertGhRepoSyncIntegrationParams{
		HTTPClient: client,
	}
}

/*
UpsertGhRepoSyncIntegrationParams contains all the parameters to send to the API endpoint

	for the upsert gh repo sync integration operation.

	Typically these are written to a http.Request.
*/
type UpsertGhRepoSyncIntegrationParams struct {

	// Body.
	Body UpsertGhRepoSyncIntegrationBody

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the upsert gh repo sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpsertGhRepoSyncIntegrationParams) WithDefaults() *UpsertGhRepoSyncIntegrationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the upsert gh repo sync integration params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpsertGhRepoSyncIntegrationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) WithTimeout(timeout time.Duration) *UpsertGhRepoSyncIntegrationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) WithContext(ctx context.Context) *UpsertGhRepoSyncIntegrationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) WithHTTPClient(client *http.Client) *UpsertGhRepoSyncIntegrationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) WithBody(body UpsertGhRepoSyncIntegrationBody) *UpsertGhRepoSyncIntegrationParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) SetBody(body UpsertGhRepoSyncIntegrationBody) {
	o.Body = body
}

// WithLocationOrganizationID adds the locationOrganizationID to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) WithLocationOrganizationID(locationOrganizationID string) *UpsertGhRepoSyncIntegrationParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) WithLocationProjectID(locationProjectID string) *UpsertGhRepoSyncIntegrationParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the upsert gh repo sync integration params
func (o *UpsertGhRepoSyncIntegrationParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *UpsertGhRepoSyncIntegrationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
